// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

//
// This file was autogenerated by a tool.
// Do not modify it.
//

namespace Microsoft.Azure.Batch
{
    using Models = Microsoft.Azure.Batch.Protocol.Models;
    using System;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// Gets the settings required for remote login to a compute node.
    /// </summary>
    public partial class RemoteLoginSettings : IPropertyMetadata
    {
        private readonly string ipAddress;
        private readonly int port;

        #region Constructors

        internal RemoteLoginSettings(Models.ComputeNodeGetRemoteLoginSettingsResult protocolObject)
        {
            this.ipAddress = protocolObject.RemoteLoginIPAddress;
            this.port = protocolObject.RemoteLoginPort;
        }

        #endregion Constructors

        #region RemoteLoginSettings

        /// <summary>
        /// Gets the IP address used for remote login to the compute node.
        /// </summary>
        public string IPAddress
        {
            get { return this.ipAddress; }
        }

        /// <summary>
        /// Gets the port used for remote login to the compute node.
        /// </summary>
        public int Port
        {
            get { return this.port; }
        }

        #endregion // RemoteLoginSettings

        #region IPropertyMetadata

        bool IModifiable.HasBeenModified
        {
            //This class is compile time readonly so it cannot have been modified
            get { return false; }
        }

        bool IReadOnly.IsReadOnly
        {
            get { return true; }
            set
            {
                // This class is compile time readonly already
            }
        }

        #endregion // IPropertyMetadata
    }
}