// Copyright (c) Microsoft and contributors.  All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//
// See the License for the specific language governing permissions and
// limitations under the License.

﻿// ------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version: 14.0.0.0
//  
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
// ------------------------------------------------------------------------------
namespace ObjectModelCodeGenerator
{
    using System;
    using System.Linq;
    using System.Text;
    using System.Collections.Generic;
    using ProxyLayerParser;
    
    /// <summary>
    /// Class to produce the template output
    /// </summary>
    [global::System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.VisualStudio.TextTemplating", "14.0.0.0")]
    public partial class NamedBatchRequests : NamedBatchRequestsBase
    {
        /// <summary>
        /// Create the template output
        /// </summary>
        public virtual string TransformText()
        {
            this.Write(@"//This file was autogenerated by a tool.  Do not modify it by hand.
namespace Microsoft.Azure.Batch.Protocol.BatchRequests
{
    using System.Collections.Generic;
    using System.Threading;
    using Rest.Azure;
    using Microsoft.Azure.Batch.Protocol.Models;

");

foreach (var group in batchRequests)
{

            this.Write("    #region ");
            this.Write(this.ToStringHelper.ToStringWithCulture(group.Name));
            this.Write("\r\n\r\n");

    foreach (var batchRequest in group.BatchRequests)
    {
        var fullClassName = group.Name + batchRequest.OperationType;

            this.Write("    /// <summary>\r\n    /// An <see cref=\"IBatchRequest\"/> for the ");
            this.Write(this.ToStringHelper.ToStringWithCulture(fullClassName));
            this.Write(" operation.\r\n    /// </summary>\r\n");

        if (string.IsNullOrEmpty(batchRequest.ParameterType))
        {

            this.Write("    public class ");
            this.Write(this.ToStringHelper.ToStringWithCulture(fullClassName));
            this.Write("BatchRequest : Protocol.BatchRequest<\r\n        ");
            this.Write(this.ToStringHelper.ToStringWithCulture(batchRequest.OptionsType));
            this.Write(",\r\n        ");
            this.Write(this.ToStringHelper.ToStringWithCulture(batchRequest.ReturnType));
            this.Write(">\r\n");

        }
        else
        {

            this.Write("    public class ");
            this.Write(this.ToStringHelper.ToStringWithCulture(fullClassName));
            this.Write("BatchRequest : Protocol.BatchRequest<\r\n        ");
            this.Write(this.ToStringHelper.ToStringWithCulture(batchRequest.ParameterType));
            this.Write(",\r\n        ");
            this.Write(this.ToStringHelper.ToStringWithCulture(batchRequest.OptionsType));
            this.Write(",\r\n        ");
            this.Write(this.ToStringHelper.ToStringWithCulture(batchRequest.ReturnType));
            this.Write(">\r\n");

        }

            this.Write("    {\r\n        /// <summary>\r\n        /// Initializes a new instance of the <see " +
                    "cref=\"");
            this.Write(this.ToStringHelper.ToStringWithCulture(fullClassName));
            this.Write("BatchRequest\" /> class.\r\n        /// </summary>\r\n        /// <param name=\"service" +
                    "Client\">The service client to use.</param>\r\n");

        if (!string.IsNullOrEmpty(batchRequest.ParameterType))
        {

            this.Write("        /// <param name=\"parameters\">The parameters to use.</param>\r\n");

        }

            this.Write("        /// <param name=\"cancellationToken\">A <see cref=\"CancellationToken\"/> con" +
                    "trolling the request lifetime.</param>\r\n");

        if (string.IsNullOrEmpty(batchRequest.ParameterType))
        {

            this.Write("        public ");
            this.Write(this.ToStringHelper.ToStringWithCulture(fullClassName));
            this.Write("BatchRequest(\r\n            BatchServiceClient serviceClient,\r\n            Cancell" +
                    "ationToken cancellationToken) : base(serviceClient, cancellationToken)\r\n");

        }
        else
        {

            this.Write("        public ");
            this.Write(this.ToStringHelper.ToStringWithCulture(fullClassName));
            this.Write("BatchRequest(\r\n            BatchServiceClient serviceClient,\r\n            ");
            this.Write(this.ToStringHelper.ToStringWithCulture(batchRequest.ParameterType));
            this.Write(" parameters,\r\n            CancellationToken cancellationToken) : base(serviceClie" +
                    "nt, parameters, cancellationToken)\r\n");

        }

            this.Write("        {\r\n        }\r\n    }\r\n\r\n");

    }

            this.Write("    #endregion\r\n\r\n");

}

            this.Write("}\r\n");
            return this.GenerationEnvironment.ToString();
        }

private global::System.Collections.Generic.IEnumerable<ProxyLayerParser.BatchRequestGroup> _batchRequestsField;

/// <summary>
/// Access the batchRequests parameter of the template.
/// </summary>
private global::System.Collections.Generic.IEnumerable<ProxyLayerParser.BatchRequestGroup> batchRequests
{
    get
    {
        return this._batchRequestsField;
    }
}


/// <summary>
/// Initialize the template
/// </summary>
public virtual void Initialize()
{
    if ((this.Errors.HasErrors == false))
    {
bool batchRequestsValueAcquired = false;
if (this.Session.ContainsKey("batchRequests"))
{
    this._batchRequestsField = ((global::System.Collections.Generic.IEnumerable<ProxyLayerParser.BatchRequestGroup>)(this.Session["batchRequests"]));
    batchRequestsValueAcquired = true;
}
if ((batchRequestsValueAcquired == false))
{
    object data = global::System.Runtime.Remoting.Messaging.CallContext.LogicalGetData("batchRequests");
    if ((data != null))
    {
        this._batchRequestsField = ((global::System.Collections.Generic.IEnumerable<ProxyLayerParser.BatchRequestGroup>)(data));
    }
}


    }
}


    }
    #region Base class
    /// <summary>
    /// Base class for this transformation
    /// </summary>
    [global::System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.VisualStudio.TextTemplating", "14.0.0.0")]
    public class NamedBatchRequestsBase
    {
        #region Fields
        private global::System.Text.StringBuilder generationEnvironmentField;
        private global::System.CodeDom.Compiler.CompilerErrorCollection errorsField;
        private global::System.Collections.Generic.List<int> indentLengthsField;
        private string currentIndentField = "";
        private bool endsWithNewline;
        private global::System.Collections.Generic.IDictionary<string, object> sessionField;
        #endregion
        #region Properties
        /// <summary>
        /// The string builder that generation-time code is using to assemble generated output
        /// </summary>
        protected System.Text.StringBuilder GenerationEnvironment
        {
            get
            {
                if ((this.generationEnvironmentField == null))
                {
                    this.generationEnvironmentField = new global::System.Text.StringBuilder();
                }
                return this.generationEnvironmentField;
            }
            set
            {
                this.generationEnvironmentField = value;
            }
        }
        /// <summary>
        /// The error collection for the generation process
        /// </summary>
        public System.CodeDom.Compiler.CompilerErrorCollection Errors
        {
            get
            {
                if ((this.errorsField == null))
                {
                    this.errorsField = new global::System.CodeDom.Compiler.CompilerErrorCollection();
                }
                return this.errorsField;
            }
        }
        /// <summary>
        /// A list of the lengths of each indent that was added with PushIndent
        /// </summary>
        private System.Collections.Generic.List<int> indentLengths
        {
            get
            {
                if ((this.indentLengthsField == null))
                {
                    this.indentLengthsField = new global::System.Collections.Generic.List<int>();
                }
                return this.indentLengthsField;
            }
        }
        /// <summary>
        /// Gets the current indent we use when adding lines to the output
        /// </summary>
        public string CurrentIndent
        {
            get
            {
                return this.currentIndentField;
            }
        }
        /// <summary>
        /// Current transformation session
        /// </summary>
        public virtual global::System.Collections.Generic.IDictionary<string, object> Session
        {
            get
            {
                return this.sessionField;
            }
            set
            {
                this.sessionField = value;
            }
        }
        #endregion
        #region Transform-time helpers
        /// <summary>
        /// Write text directly into the generated output
        /// </summary>
        public void Write(string textToAppend)
        {
            if (string.IsNullOrEmpty(textToAppend))
            {
                return;
            }
            // If we're starting off, or if the previous text ended with a newline,
            // we have to append the current indent first.
            if (((this.GenerationEnvironment.Length == 0) 
                        || this.endsWithNewline))
            {
                this.GenerationEnvironment.Append(this.currentIndentField);
                this.endsWithNewline = false;
            }
            // Check if the current text ends with a newline
            if (textToAppend.EndsWith(global::System.Environment.NewLine, global::System.StringComparison.CurrentCulture))
            {
                this.endsWithNewline = true;
            }
            // This is an optimization. If the current indent is "", then we don't have to do any
            // of the more complex stuff further down.
            if ((this.currentIndentField.Length == 0))
            {
                this.GenerationEnvironment.Append(textToAppend);
                return;
            }
            // Everywhere there is a newline in the text, add an indent after it
            textToAppend = textToAppend.Replace(global::System.Environment.NewLine, (global::System.Environment.NewLine + this.currentIndentField));
            // If the text ends with a newline, then we should strip off the indent added at the very end
            // because the appropriate indent will be added when the next time Write() is called
            if (this.endsWithNewline)
            {
                this.GenerationEnvironment.Append(textToAppend, 0, (textToAppend.Length - this.currentIndentField.Length));
            }
            else
            {
                this.GenerationEnvironment.Append(textToAppend);
            }
        }
        /// <summary>
        /// Write text directly into the generated output
        /// </summary>
        public void WriteLine(string textToAppend)
        {
            this.Write(textToAppend);
            this.GenerationEnvironment.AppendLine();
            this.endsWithNewline = true;
        }
        /// <summary>
        /// Write formatted text directly into the generated output
        /// </summary>
        public void Write(string format, params object[] args)
        {
            this.Write(string.Format(global::System.Globalization.CultureInfo.CurrentCulture, format, args));
        }
        /// <summary>
        /// Write formatted text directly into the generated output
        /// </summary>
        public void WriteLine(string format, params object[] args)
        {
            this.WriteLine(string.Format(global::System.Globalization.CultureInfo.CurrentCulture, format, args));
        }
        /// <summary>
        /// Raise an error
        /// </summary>
        public void Error(string message)
        {
            System.CodeDom.Compiler.CompilerError error = new global::System.CodeDom.Compiler.CompilerError();
            error.ErrorText = message;
            this.Errors.Add(error);
        }
        /// <summary>
        /// Raise a warning
        /// </summary>
        public void Warning(string message)
        {
            System.CodeDom.Compiler.CompilerError error = new global::System.CodeDom.Compiler.CompilerError();
            error.ErrorText = message;
            error.IsWarning = true;
            this.Errors.Add(error);
        }
        /// <summary>
        /// Increase the indent
        /// </summary>
        public void PushIndent(string indent)
        {
            if ((indent == null))
            {
                throw new global::System.ArgumentNullException("indent");
            }
            this.currentIndentField = (this.currentIndentField + indent);
            this.indentLengths.Add(indent.Length);
        }
        /// <summary>
        /// Remove the last indent that was added with PushIndent
        /// </summary>
        public string PopIndent()
        {
            string returnValue = "";
            if ((this.indentLengths.Count > 0))
            {
                int indentLength = this.indentLengths[(this.indentLengths.Count - 1)];
                this.indentLengths.RemoveAt((this.indentLengths.Count - 1));
                if ((indentLength > 0))
                {
                    returnValue = this.currentIndentField.Substring((this.currentIndentField.Length - indentLength));
                    this.currentIndentField = this.currentIndentField.Remove((this.currentIndentField.Length - indentLength));
                }
            }
            return returnValue;
        }
        /// <summary>
        /// Remove any indentation
        /// </summary>
        public void ClearIndent()
        {
            this.indentLengths.Clear();
            this.currentIndentField = "";
        }
        #endregion
        #region ToString Helpers
        /// <summary>
        /// Utility class to produce culture-oriented representation of an object as a string.
        /// </summary>
        public class ToStringInstanceHelper
        {
            private System.IFormatProvider formatProviderField  = global::System.Globalization.CultureInfo.InvariantCulture;
            /// <summary>
            /// Gets or sets format provider to be used by ToStringWithCulture method.
            /// </summary>
            public System.IFormatProvider FormatProvider
            {
                get
                {
                    return this.formatProviderField ;
                }
                set
                {
                    if ((value != null))
                    {
                        this.formatProviderField  = value;
                    }
                }
            }
            /// <summary>
            /// This is called from the compile/run appdomain to convert objects within an expression block to a string
            /// </summary>
            public string ToStringWithCulture(object objectToConvert)
            {
                if ((objectToConvert == null))
                {
                    throw new global::System.ArgumentNullException("objectToConvert");
                }
                System.Type t = objectToConvert.GetType();
                System.Reflection.MethodInfo method = t.GetMethod("ToString", new System.Type[] {
                            typeof(System.IFormatProvider)});
                if ((method == null))
                {
                    return objectToConvert.ToString();
                }
                else
                {
                    return ((string)(method.Invoke(objectToConvert, new object[] {
                                this.formatProviderField })));
                }
            }
        }
        private ToStringInstanceHelper toStringHelperField = new ToStringInstanceHelper();
        /// <summary>
        /// Helper to produce culture-oriented representation of an object as a string
        /// </summary>
        public ToStringInstanceHelper ToStringHelper
        {
            get
            {
                return this.toStringHelperField;
            }
        }
        #endregion
    }
    #endregion
}
