// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Automation.Models;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the configuration property type.
    /// </summary>
    public partial class DscConfigurationProperties : ResourceCommonPropertiesBase
    {
        private int _jobCount;
        
        /// <summary>
        /// Optional. Gets or sets the job count of the configuration.
        /// </summary>
        public int JobCount
        {
            get { return this._jobCount; }
            set { this._jobCount = value; }
        }
        
        private bool _logVerbose;
        
        /// <summary>
        /// Optional. Gets or sets verbose log option.
        /// </summary>
        public bool LogVerbose
        {
            get { return this._logVerbose; }
            set { this._logVerbose = value; }
        }
        
        private IDictionary<string, DscConfigurationParameter> _parameters;
        
        /// <summary>
        /// Optional. Gets or sets the configuration parameters.
        /// </summary>
        public IDictionary<string, DscConfigurationParameter> Parameters
        {
            get { return this._parameters; }
            set { this._parameters = value; }
        }
        
        private DscConfigurationProvisioningState _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets the provisioning state of the configuration.
        /// </summary>
        public DscConfigurationProvisioningState ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private ContentSource _source;
        
        /// <summary>
        /// Optional. Gets or sets the source.
        /// </summary>
        public ContentSource Source
        {
            get { return this._source; }
            set { this._source = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. Gets or sets the state of the configuration.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DscConfigurationProperties class.
        /// </summary>
        public DscConfigurationProperties()
        {
            this.Parameters = new LazyDictionary<string, DscConfigurationParameter>();
        }
    }
}
