// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Profile for Windows VMs
    /// </summary>
    public partial class ContainerServiceWindowsProfile
    {
        /// <summary>
        /// Initializes a new instance of the ContainerServiceWindowsProfile
        /// class.
        /// </summary>
        public ContainerServiceWindowsProfile() { }

        /// <summary>
        /// Initializes a new instance of the ContainerServiceWindowsProfile
        /// class.
        /// </summary>
        public ContainerServiceWindowsProfile(string adminUsername, string adminPassword)
        {
            AdminUsername = adminUsername;
            AdminPassword = adminPassword;
        }

        /// <summary>
        /// The administrator username to use for Windows VMs
        /// </summary>
        [JsonProperty(PropertyName = "adminUsername")]
        public string AdminUsername { get; set; }

        /// <summary>
        /// The administrator password to use for Windows VMs
        /// </summary>
        [JsonProperty(PropertyName = "adminPassword")]
        public string AdminPassword { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (AdminUsername == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AdminUsername");
            }
            if (AdminPassword == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "AdminPassword");
            }
        }
    }
}
