// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A Data Lake Analytics catalog external table item.
    /// </summary>
    public partial class ExternalTable
    {
        /// <summary>
        /// Initializes a new instance of the ExternalTable class.
        /// </summary>
        public ExternalTable() { }

        /// <summary>
        /// Initializes a new instance of the ExternalTable class.
        /// </summary>
        /// <param name="tableName">the name of the table associated with this
        /// database and schema.</param>
        /// <param name="dataSource">the data source associated with this
        /// external table.</param>
        public ExternalTable(string tableName = default(string), EntityId dataSource = default(EntityId))
        {
            TableName = tableName;
            DataSource = dataSource;
        }

        /// <summary>
        /// Gets or sets the name of the table associated with this database
        /// and schema.
        /// </summary>
        [JsonProperty(PropertyName = "tableName")]
        public string TableName { get; set; }

        /// <summary>
        /// Gets or sets the data source associated with this external table.
        /// </summary>
        [JsonProperty(PropertyName = "dataSource")]
        public EntityId DataSource { get; set; }

    }
}
