// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Properties for creating a custom image from a VHD.
    /// </summary>
    public partial class CustomImagePropertiesCustom
    {
        /// <summary>
        /// Initializes a new instance of the CustomImagePropertiesCustom
        /// class.
        /// </summary>
        public CustomImagePropertiesCustom() { }

        /// <summary>
        /// Initializes a new instance of the CustomImagePropertiesCustom
        /// class.
        /// </summary>
        public CustomImagePropertiesCustom(string imageName = default(string), bool? sysPrep = default(bool?), string osType = default(string))
        {
            ImageName = imageName;
            SysPrep = sysPrep;
            OsType = osType;
        }

        /// <summary>
        /// The image name.
        /// </summary>
        [JsonProperty(PropertyName = "imageName")]
        public string ImageName { get; set; }

        /// <summary>
        /// Indicates whether sysprep has been run on the VHD.
        /// </summary>
        [JsonProperty(PropertyName = "sysPrep")]
        public bool? SysPrep { get; set; }

        /// <summary>
        /// The OS type of the custom image. Possible values include:
        /// 'Windows', 'Linux', 'None'
        /// </summary>
        [JsonProperty(PropertyName = "osType")]
        public string OsType { get; set; }

    }
}
