// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.EventHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Parameters supplied to the CreateOrUpdate EventHub operation.
    /// </summary>
    public partial class EventHubCreateOrUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the EventHubCreateOrUpdateParameters
        /// class.
        /// </summary>
        public EventHubCreateOrUpdateParameters() { }

        /// <summary>
        /// Initializes a new instance of the EventHubCreateOrUpdateParameters
        /// class.
        /// </summary>
        public EventHubCreateOrUpdateParameters(string location, string type = default(string), string name = default(string), EventHubProperties properties = default(EventHubProperties))
        {
            Location = location;
            Type = type;
            Name = name;
            Properties = properties;
        }

        /// <summary>
        /// Location of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// ARM type of the namespace.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Name of the Event Hub.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public EventHubProperties Properties { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (Location == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Location");
            }
        }
    }
}
