// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// Parameters supplied to the Create or Update service configuration.
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class ServiceDiagnosticSettingsCreateOrUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ServiceDiagnosticSettingsCreateOrUpdateParameters class.
        /// </summary>
        public ServiceDiagnosticSettingsCreateOrUpdateParameters() { }

        /// <summary>
        /// Initializes a new instance of the
        /// ServiceDiagnosticSettingsCreateOrUpdateParameters class.
        /// </summary>
        /// <param name="storageAccountId">the resource id of the storage
        /// account.</param>
        /// <param name="serviceBusRuleId">the id of the service bus
        /// rule.</param>
        /// <param name="metrics">the list of metrics.</param>
        /// <param name="logs">the list of logs.</param>
        /// <param name="workspaceId">the OMS workspace Id.</param>
        public ServiceDiagnosticSettingsCreateOrUpdateParameters(string storageAccountId = default(string), string serviceBusRuleId = default(string), System.Collections.Generic.IList<MetricSettings> metrics = default(System.Collections.Generic.IList<MetricSettings>), System.Collections.Generic.IList<LogSettings> logs = default(System.Collections.Generic.IList<LogSettings>), string workspaceId = default(string))
        {
            StorageAccountId = storageAccountId;
            ServiceBusRuleId = serviceBusRuleId;
            Metrics = metrics;
            Logs = logs;
            WorkspaceId = workspaceId;
        }

        /// <summary>
        /// Gets or sets the resource id of the storage account.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.storageAccountId")]
        public string StorageAccountId { get; set; }

        /// <summary>
        /// Gets or sets the id of the service bus rule.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.serviceBusRuleId")]
        public string ServiceBusRuleId { get; set; }

        /// <summary>
        /// Gets or sets the list of metrics.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.metrics")]
        public System.Collections.Generic.IList<MetricSettings> Metrics { get; set; }

        /// <summary>
        /// Gets or sets the list of logs.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.logs")]
        public System.Collections.Generic.IList<LogSettings> Logs { get; set; }

        /// <summary>
        /// Gets or sets the OMS workspace Id.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.workspaceId")]
        public string WorkspaceId { get; set; }

    }
}
