// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Used to provide parameters when requesting an export of all devices in
    /// the hub.
    /// </summary>
    public partial class ExportDevicesRequest
    {
        /// <summary>
        /// Initializes a new instance of the ExportDevicesRequest class.
        /// </summary>
        public ExportDevicesRequest() { }

        /// <summary>
        /// Initializes a new instance of the ExportDevicesRequest class.
        /// </summary>
        public ExportDevicesRequest(string exportBlobContainerUri, bool excludeKeys)
        {
            ExportBlobContainerUri = exportBlobContainerUri;
            ExcludeKeys = excludeKeys;
        }

        /// <summary>
        /// The export BLOB container URI.
        /// </summary>
        [JsonProperty(PropertyName = "ExportBlobContainerUri")]
        public string ExportBlobContainerUri { get; set; }

        /// <summary>
        /// The value indicating whether keys should be excluded during export.
        /// </summary>
        [JsonProperty(PropertyName = "ExcludeKeys")]
        public bool ExcludeKeys { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (ExportBlobContainerUri == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "ExportBlobContainerUri");
            }
        }
    }
}
