// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    [JsonTransformation]
    public partial class IntegrationAccountCertificate : IntegrationAccountResource
    {
        /// <summary>
        /// Initializes a new instance of the IntegrationAccountCertificate
        /// class.
        /// </summary>
        public IntegrationAccountCertificate() { }

        /// <summary>
        /// Initializes a new instance of the IntegrationAccountCertificate
        /// class.
        /// </summary>
        public IntegrationAccountCertificate(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), DateTime? createdTime = default(DateTime?), DateTime? changedTime = default(DateTime?), object metadata = default(object), KeyVaultKeyReference key = default(KeyVaultKeyReference), string publicCertificate = default(string))
            : base(id, name, type, location, tags)
        {
            CreatedTime = createdTime;
            ChangedTime = changedTime;
            Metadata = metadata;
            Key = key;
            PublicCertificate = publicCertificate;
        }

        /// <summary>
        /// Gets the created time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdTime")]
        public DateTime? CreatedTime { get; private set; }

        /// <summary>
        /// Gets the changed time.
        /// </summary>
        [JsonProperty(PropertyName = "properties.changedTime")]
        public DateTime? ChangedTime { get; private set; }

        /// <summary>
        /// Gets or sets the metadata.
        /// </summary>
        [JsonProperty(PropertyName = "properties.metadata")]
        public object Metadata { get; set; }

        /// <summary>
        /// Gets or sets the key details in the key vault.
        /// </summary>
        [JsonProperty(PropertyName = "properties.key")]
        public KeyVaultKeyReference Key { get; set; }

        /// <summary>
        /// Gets or sets the public certificate.
        /// </summary>
        [JsonProperty(PropertyName = "properties.publicCertificate")]
        public string PublicCertificate { get; set; }

    }
}
