// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Defines a global parameter in the graph.
    /// </summary>
    public partial class GraphParameter
    {
        /// <summary>
        /// Initializes a new instance of the GraphParameter class.
        /// </summary>
        public GraphParameter() { }

        /// <summary>
        /// Initializes a new instance of the GraphParameter class.
        /// </summary>
        /// <param name="type">Graph parameter's type. Possible values
        /// include: 'String', 'Int', 'Float', 'Enumerated', 'Script',
        /// 'Mode', 'Credential', 'Boolean', 'Double', 'ColumnPicker',
        /// 'ParameterRange', 'DataGatewayName'</param>
        /// <param name="links">Association links for this parameter to nodes
        /// in the graph.</param>
        /// <param name="description">Description of this graph
        /// parameter.</param>
        public GraphParameter(string type, System.Collections.Generic.IList<GraphParameterLink> links, string description = default(string))
        {
            Description = description;
            Type = type;
            Links = links;
        }

        /// <summary>
        /// Gets or sets description of this graph parameter.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets graph parameter's type. Possible values include:
        /// 'String', 'Int', 'Float', 'Enumerated', 'Script', 'Mode',
        /// 'Credential', 'Boolean', 'Double', 'ColumnPicker',
        /// 'ParameterRange', 'DataGatewayName'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets association links for this parameter to nodes in the
        /// graph.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "links")]
        public System.Collections.Generic.IList<GraphParameterLink> Links { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Type == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Type");
            }
            if (Links == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Links");
            }
            if (this.Links != null)
            {
                foreach (var element in this.Links)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
