// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Represents database connection string information
    /// </summary>
    public partial class ConnStringInfo
    {
        /// <summary>
        /// Initializes a new instance of the ConnStringInfo class.
        /// </summary>
        public ConnStringInfo() { }

        /// <summary>
        /// Initializes a new instance of the ConnStringInfo class.
        /// </summary>
        public ConnStringInfo(DatabaseServerType? type, string name = default(string), string connectionString = default(string))
        {
            Name = name;
            ConnectionString = connectionString;
            Type = type;
        }

        /// <summary>
        /// Name of connection string
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Connection string value
        /// </summary>
        [JsonProperty(PropertyName = "connectionString")]
        public string ConnectionString { get; set; }

        /// <summary>
        /// Type of database. Possible values for this property include:
        /// 'MySql', 'SQLServer', 'SQLAzure', 'Custom'.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public DatabaseServerType? Type { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (Type == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Type");
            }
        }
    }
}
