// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Details of a hostname derived from a domain
    /// </summary>
    public partial class HostName
    {
        /// <summary>
        /// Initializes a new instance of the HostName class.
        /// </summary>
        public HostName() { }

        /// <summary>
        /// Initializes a new instance of the HostName class.
        /// </summary>
        public HostName(string name = default(string), IList<string> siteNames = default(IList<string>), string azureResourceName = default(string), AzureResourceType? azureResourceType = default(AzureResourceType?), CustomHostNameDnsRecordType? customHostNameDnsRecordType = default(CustomHostNameDnsRecordType?), HostNameType? hostNameType = default(HostNameType?))
        {
            Name = name;
            SiteNames = siteNames;
            AzureResourceName = azureResourceName;
            AzureResourceType = azureResourceType;
            CustomHostNameDnsRecordType = customHostNameDnsRecordType;
            HostNameType = hostNameType;
        }

        /// <summary>
        /// Name of the hostname
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// List of sites the hostname is assigned to. This list will have
        /// more than one site only if the hostname is pointing to a Traffic
        /// Manager
        /// </summary>
        [JsonProperty(PropertyName = "siteNames")]
        public IList<string> SiteNames { get; set; }

        /// <summary>
        /// Name of the Azure resource the hostname is assigned to. If it is
        /// assigned to a traffic manager then it will be the traffic manager
        /// name otherwise it will be the website name
        /// </summary>
        [JsonProperty(PropertyName = "azureResourceName")]
        public string AzureResourceName { get; set; }

        /// <summary>
        /// Type of the Azure resource the hostname is assigned to. Possible
        /// values for this property include: 'Website', 'TrafficManager'.
        /// </summary>
        [JsonProperty(PropertyName = "azureResourceType")]
        public AzureResourceType? AzureResourceType { get; set; }

        /// <summary>
        /// Type of the Dns record. Possible values for this property include:
        /// 'CName', 'A'.
        /// </summary>
        [JsonProperty(PropertyName = "customHostNameDnsRecordType")]
        public CustomHostNameDnsRecordType? CustomHostNameDnsRecordType { get; set; }

        /// <summary>
        /// Type of the hostname. Possible values for this property include:
        /// 'Verified', 'Managed'.
        /// </summary>
        [JsonProperty(PropertyName = "hostNameType")]
        public HostNameType? HostNameType { get; set; }

    }
}
