// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Removes elisions. For example, "l'avion" (the plane) will be converted
    /// to "avion" (plane). This token filter is implemented using Apache
    /// Lucene.
    /// <see href="http://lucene.apache.org/core/4_10_3/analyzers-common/org/apache/lucene/analysis/util/ElisionFilter.html" />
    /// </summary>
    [JsonObject("#Microsoft.Azure.Search.ElisionTokenFilter")]
    public partial class ElisionTokenFilter : TokenFilter
    {
        /// <summary>
        /// Initializes a new instance of the ElisionTokenFilter class.
        /// </summary>
        public ElisionTokenFilter() { }

        /// <summary>
        /// Initializes a new instance of the ElisionTokenFilter class.
        /// </summary>
        public ElisionTokenFilter(string name, IList<string> articles = default(IList<string>))
            : base(name)
        {
            Articles = articles;
        }

        /// <summary>
        /// Gets or sets the set of articles to remove.
        /// </summary>
        [JsonProperty(PropertyName = "articles")]
        public IList<string> Articles { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
